<template>
    <div>
      <div v-if="loading">Verificando token...</div>
      <div v-else>
        <div v-if="verificationSuccessful">
          <div class="register">
            <div class="container-half1">
              <CarouselComponent :imagenes="['https://i.ibb.co/0tg3p9X/Nueva-contrase-a1.png']" />
            </div>
            <div class="container-half2">
              <div class="login-container">
                <h2 class="mb-4 title">Recuperación de contraseña</h2>
                <h4 class="mb-4 subtitle">Ingresa tu nueva contraseña</h4>
                <br><br>
                <form @submit.prevent="submitPasswordForm">
                  <div class="form-group mb-3">
                    <input type="password" class="form-control" id="newPassword" v-model="newPassword" placeholder="Nueva contraseña" required>
                    <div class="invalid-feedback" v-if="newPassword.length < 8">La contraseña debe tener al menos 8 caracteres.</div>
                  </div>
                  <div class="form-group mb-3">
                    <input type="password" class="form-control" id="confirmNewPassword" v-model="confirmNewPassword" placeholder="Confirmar nueva contraseña" required>
                    <div class="error-message" v-if="newPassword !== confirmNewPassword">Las contraseñas no coinciden</div>
                  </div>
                  <br><br>
                  <button type="submit" class="btn btn-primary btn-block mb-3">Actualizar nueva contraseña</button>
                  <router-link to="/Login"><button class="btn btn-secondary btn-block">Volver</button></router-link>
                </form>
              </div>
            </div>
          </div>
        </div>
        <div v-else>
          <div class="container">
            <div class="card">Error al verificar el token</div>
          </div>
        </div>
      </div>
    </div>
  </template>
  
  <script>
  import axios from 'axios';
  import CarouselComponent from '../../../components/cuenta/CarouselComponent.vue';
  
  export default {
    name: 'PasswordRecoveryPage',
    components: {
      CarouselComponent,
    },
    data() {
      return {
        loading: true,
        verificationSuccessful: false,
        newPassword: '',
        confirmNewPassword: '',
        usuario: null,
      };
    },
    async created() {
      const token = this.$route.query.token;
      try {
        const response = await axios.get('http://localhost:3001/usuarios/verificar-token-recuperacion', {
          params: {
            token: token,
          },
        });
        if (response.status === 200) {
          this.verificationSuccessful = true;
          this.usuario = response.data;
        } else {
          console.error('Error al verificar el token:', response.data);
        }
      } catch (error) {
        console.error('Error al verificar el token:', error);
      } finally {
        this.loading = false;
      }
    },
    methods: {
      async submitPasswordForm() {
        // Verificar si las contraseñas coinciden
        if (this.newPassword.length < 8) {
          alert('La contraseña debe tener al menos 8 caracteres de largo.');
          return;
        }
        if (this.newPassword !== this.confirmNewPassword) {
          alert('Las contraseñas no coinciden.');
          return;
        }
  
        // Aquí puedes hacer la petición POST para cambiar la contraseña
        try {
          const response = await axios.post('http://localhost:3001/usuarios/ingreso-contrasena-recuperacion', {
            id: this.usuario.id, // Asegúrate de que el ID del usuario está disponible
            nuevaContrasena: this.newPassword,
          });
          if (response.status === 200) {
            console.log('Contraseña cambiada exitosamente');
            this.$router.push('/Login'); // Redirigir al usuario a la página de inicio de sesión
          } else {
            console.error('Error al cambiar la contraseña:', response.data);
          }
        } catch (error) {
          console.error('Error al cambiar la contraseña:', error);
        }
      },
    },
  };
  </script>
  
  <style scoped>
  .container {
  display: flex;
  align-items: center;
  justify-content: center;
  height: 100vh;
}

.card {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  width: 400px;
  height: 30vh;
  padding: 20px;
  border-radius: 10px;
  background-color: #2148c0;
  color: #e4e6eb;
  box-shadow: 0px 10px 30px -5px rgba(0, 0, 0, 0.3);
}

p {
  margin: 20px 0;
  font-size: 18px;
  line-height: 24px;
}
  .login-container {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    padding: 20px;
  }
  
  .login-container .form-group {
    width: 100%;
    margin-bottom: 30px;
  }
  
  .login-container .form-group .invalid-feedback {
    min-height: 20px;
    color: red;
  }
  
  .login-container button {
    width: 100%;
  }
  
  .login-container button.btn-primary {
    color: #fff;
  }
  
  .register {
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
    height: 100vh;
    background-color: #ffffff;
  }
  
  .container-half2 {
    width: 50%;
  }
  
  .container-half1 {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100%;
    width: 50%;
    background-color: #4d6dcf;
  }
  
  .register-container {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    padding: 20px;
  }
  
  .register-container .form-group {
    width: 100%;
    margin-bottom: 30px;
  }
  
  .register-container .form-group .invalid-feedback {
    min-height: 20px; 
    color: red;
  }
  
  .register-container button {
    width: 100%;
  }
  
  .register-container button.btn-primary {
    color: #fff;
  }
  .register-container .form-group .error-message {
  min-height: 20px; 
  color: red;
}
  </style>
  